<?php

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/*
Plugin Name: Events Made Easy
Version: 2.1.43
Plugin URI: https://www.e-dynamics.be/wordpress
Description: Manage and display events and memberships. Also includes recurring events; locations; widgets; maps; RSVP; ICAL and RSS feeds; Paypal, 2Checkout and others.
Author: Franky Van Liedekerke
Author URI: https://www.e-dynamics.be/
Text Domain: events-made-easy
Domain Path: /langs
*/

/*
Copyright (c) 2010-2019, Franky Van Liedekerke.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

// Setting constants
define('EME_VERSION', '2.1.43');
define('EME_DB_VERSION', 253);
define('EME_PLUGIN_URL', plugins_url('',plugin_basename(__FILE__)).'/'); //PLUGIN URL
define('EME_PLUGIN_DIR', ABSPATH.PLUGINDIR.'/'.str_replace(basename( __FILE__),"",plugin_basename(__FILE__)).'/'); //PLUGIN DIRECTORY
define('EVENTS_TBNAME','eme_events');
define('EVENTS_CF_TBNAME', 'eme_events_cf');
define('RECURRENCE_TBNAME','eme_recurrence');
define('LOCATIONS_TBNAME','eme_locations');
define('LOCATIONS_CF_TBNAME', 'eme_locations_cf');
define('BOOKINGS_TBNAME','eme_bookings');
define('PEOPLE_TBNAME','eme_people');
define('GROUPS_TBNAME','eme_groups');
define('USERGROUPS_TBNAME','eme_usergroups');
define('CATEGORIES_TBNAME', 'eme_categories');
define('HOLIDAYS_TBNAME', 'eme_holidays');
define('TEMPLATES_TBNAME', 'eme_templates');
define('FORMFIELDS_TBNAME', 'eme_formfields');
define('FIELDTYPES_TBNAME', 'eme_fieldtypes');
define('ANSWERS_TBNAME', 'eme_answers');
define('PAYMENTS_TBNAME', 'eme_payments');
define('DISCOUNTS_TBNAME', 'eme_discounts');
define('DISCOUNTGROUPS_TBNAME', 'eme_dgroups');
define('MQUEUE_TBNAME', 'eme_mqueue');
define('MAILINGS_TBNAME', 'eme_mailings');
define('MEMBERS_TBNAME', 'eme_members');
define('MEMBERSHIPS_TBNAME', 'eme_memberships');
define('MEMBERSHIPS_CF_TBNAME', 'eme_memberships_cf');
define('COUNTRIES_TBNAME', 'eme_countries');
define('STATES_TBNAME', 'eme_states');
define('DEFAULT_CAP_ADD_EVENT','edit_posts');
define('DEFAULT_CAP_AUTHOR_EVENT','publish_posts');
define('DEFAULT_CAP_PUBLISH_EVENT','publish_posts');
define('DEFAULT_CAP_LIST_EVENTS','edit_posts');
define('DEFAULT_CAP_EDIT_EVENTS','edit_others_posts');
define('DEFAULT_CAP_LIST_LOCATIONS','edit_others_posts');
define('DEFAULT_CAP_ADD_LOCATION','edit_others_posts');
define('DEFAULT_CAP_AUTHOR_LOCATION','edit_others_posts');
define('DEFAULT_CAP_EDIT_LOCATIONS','edit_others_posts');
define('DEFAULT_CAP_CATEGORIES','activate_plugins');
define('DEFAULT_CAP_HOLIDAYS','activate_plugins');
define('DEFAULT_CAP_TEMPLATES','activate_plugins');
define('DEFAULT_CAP_LIST_PEOPLE','edit_posts');
define('DEFAULT_CAP_EDIT_PEOPLE','edit_others_posts');
define('DEFAULT_CAP_AUTHOR_PERSON','edit_posts');
define('DEFAULT_CAP_DISCOUNTS','edit_posts');
define('DEFAULT_CAP_LIST_MEMBERS','edit_posts');
define('DEFAULT_CAP_EDIT_MEMBERS','edit_others_posts');
define('DEFAULT_CAP_AUTHOR_MEMBER','edit_posts');
define('DEFAULT_CAP_LIST_REGISTRATIONS','edit_posts');
define('DEFAULT_CAP_LIST_APPROVE','edit_posts');
define('DEFAULT_CAP_AUTHOR_APPROVE','edit_posts');
define('DEFAULT_CAP_APPROVE','edit_others_posts');
define('DEFAULT_CAP_AUTHOR_REGISTRATIONS','edit_posts');
define('DEFAULT_CAP_REGISTRATIONS','edit_others_posts');
define('DEFAULT_CAP_ATTENDANCECHECK','edit_posts');
define('DEFAULT_CAP_MEMBERCHECK','edit_posts');
define('DEFAULT_CAP_FORMS','edit_others_posts');
define('DEFAULT_CAP_CLEANUP','activate_plugins');
define('DEFAULT_CAP_SETTINGS','activate_plugins');
define('DEFAULT_CAP_SEND_MAILS','edit_posts');
define('DEFAULT_CAP_SEND_OTHER_MAILS','edit_others_posts');
define('DEFAULT_EVENT_LIST_HEADER_FORMAT',"<ul class='eme_events_list'>");
define('DEFAULT_EVENT_LIST_FOOTER_FORMAT','</ul>');
define('DEFAULT_CAT_EVENT_LIST_HEADER_FORMAT',"<ul class='eme_events_list'>");
define('DEFAULT_CAT_EVENT_LIST_FOOTER_FORMAT','</ul>');
define('DEFAULT_EVENTS_PAGE_TITLE',__('Events','events-made-easy') ) ;
define('DEFAULT_EVENT_HTML_TITLE_FORMAT', '#_EVENTNAME'); 
define('DEFAULT_WIDGET_EVENT_LIST_ITEM_FORMAT','<li>#_LINKEDNAME<ul><li>#_STARTDATE</li><li>#_TOWN</li></ul></li>');
define('DEFAULT_NO_EVENTS_MESSAGE', __('No events', 'events-made-easy'));
define('DEFAULT_LOCATION_HTML_TITLE_FORMAT', '#_LOCATIONNAME'); 
define('DEFAULT_LOCATION_LIST_HEADER_FORMAT',"<ul class='eme_locations_list'>");
define('DEFAULT_LOCATION_EVENT_LIST_ITEM_FORMAT', "<li>#_EVENTNAME - #_STARTDATE - #_STARTTIME</li>");
define('DEFAULT_LOCATION_LIST_FOOTER_FORMAT','</ul>');
define('DEFAULT_BOOKINGS_LIST_HEADER_FORMAT',"<ul class='eme_bookings_list_ul'>");
define('DEFAULT_BOOKINGS_LIST_FOOTER_FORMAT','</ul>');
define('DEFAULT_SHOW_PERIOD_MONTHLY_DATEFORMAT', "F, Y");
define('DEFAULT_SHOW_PERIOD_YEARLY_DATEFORMAT', "Y");
define('DEFAULT_FILTER_FORM_FORMAT', "#_FILTER_CATS #_FILTER_LOCS");
define('EME_DEFAULT_CATEGORIES_SEPARATOR',', ');
define('EME_DEFAULT_CATEGORYDESCRIPTIONS_SEPARATOR',', ');
define('EME_DEFAULT_LINKEDCATEGORIES_SEPARATOR',', ');
define('STATUS_TRASH', 0);
define('STATUS_PUBLIC', 1);
define('STATUS_PRIVATE', 2);
define('STATUS_DRAFT', 5);
define('RSVP_STATUS_ACTIVE', 1);
define('RSVP_STATUS_TRASH', 0);
define('PEOPLE_STATUS_ACTIVE', 1);
define('PEOPLE_STATUS_TRASH', 0);
define('MEMBER_STATUS_PENDING', 0);
define('MEMBER_STATUS_ACTIVE', 1);
define('MEMBER_STATUS_GRACE', 99);
define('MEMBER_STATUS_EXPIRED', 100);
$upload_info = wp_upload_dir();
define("EME_UPLOAD_DIR", $upload_info['basedir']."/events-made-easy");
define("EME_UPLOAD_URL", $upload_info['baseurl']."/events-made-easy");
if (!is_dir(EME_UPLOAD_DIR)) {
	wp_mkdir_p(EME_UPLOAD_DIR);
}
if (!is_dir(EME_UPLOAD_DIR."/bookings")) {
	wp_mkdir_p(EME_UPLOAD_DIR."/bookings");
}
if (!is_file(EME_UPLOAD_DIR."/bookings/index.html")) {
	touch(EME_UPLOAD_DIR."/bookings/index.html");
}
if (!is_dir(EME_UPLOAD_DIR."/people")) {
	wp_mkdir_p(EME_UPLOAD_DIR."/people");
}
if (!is_file(EME_UPLOAD_DIR."/people/index.html")) {
	touch(EME_UPLOAD_DIR."/people/index.html");
}
if (!is_dir(EME_UPLOAD_DIR."/members")) {
	wp_mkdir_p(EME_UPLOAD_DIR."/members");
}
if (!is_file(EME_UPLOAD_DIR."/members/index.html")) {
	touch(EME_UPLOAD_DIR."/members/index.html");
}
define("CO_LIVE_URL","https://www.2checkout.com/checkout/purchase");
define("CO_SANDBOX_URL","https://sandbox.2checkout.com/checkout/purchase");
define("PAYPAL_LIVE_URL","https://www.paypal.com/cgi-bin/webscr");
define("PAYPAL_IPN_LIVE_URL","https://ipnpb.paypal.com/cgi-bin/webscr");
define("PAYPAL_SANDBOX_URL","https://www.sandbox.paypal.com/cgi-bin/webscr");
define("PAYPAL_IPN_SANDBOX_URL","https://ipnpb.sandbox.paypal.com/cgi-bin/webscr");
define("WORLDPAY_SANDBOX_URL","https://secure-test.worldpay.com/wcc/purchase");
define("WORLDPAY_LIVE_URL","https://secure.worldpay.com/wcc/purchase");
define("FDGG_SANDBOX_URL","https://connect.merchanttest.firstdataglobalgateway.com/IPGConnect/gateway/processing");
define("FDGG_LIVE_URL","https://connect.firstdataglobalgateway.com/IPGConnect/gateway/processing");
define("SAGEPAY_SANDBOX_URL","https://test.sagepay.com/gateway/service/vspform-register.vsp");
define("SAGEPAY_LIVE_URL","https://live.sagepay.com/gateway/service/vspform-register.vsp");

add_filter( 'plugin_row_meta', 'eme_plugin_row_meta', 10, 2 );
function eme_plugin_row_meta( $links, $file ) {

	if ( strpos( $file, 'events-manager.php' ) !== false ) {
		$new_links = array(
				'donate' => '<a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=SMGDS4GLCYWNG&lc=BE&item_name=To%20support%20development%20of%20EME&currency_code=EUR&bn=PP%2dDonationsBF%3abtn_donateCC_LG%2egif%3aNonHosted">Donate</a>',
                                'Support' => '<a href="https://www.e-dynamics.be/wordpress">Support</a>'
				);
		$links = array_merge( $links, $new_links );
	}
	return $links;
}
add_filter( 'plugin_action_links_' . plugin_basename(__FILE__), 'eme_add_action_links' );
function eme_add_action_links ( $links ) {
 $mylinks = array('<a href="admin.php?page=eme-options">Settings</a>');
return array_merge( $links, $mylinks );
}

// To enable activation through the activate function
register_activation_hook(__FILE__,'eme_install');
// when deactivation is needed
register_deactivation_hook(__FILE__,'eme_uninstall');
// when a new blog is added for network installation and the plugin is network activated
add_action( 'wpmu_new_blog', 'eme_new_blog', 10, 6);      
// to execute a db update after auto-update of EME
//add_action( 'plugins_loaded', 'eme_install' );

// filters for general events field (corresponding to those of "the_title")
add_filter('eme_general', 'wptexturize');
add_filter('eme_general', 'convert_chars');
add_filter('eme_general', 'trim');

// TEXT content filter
add_filter('eme_text', 'wp_strip_all_tags');
add_filter('eme_text', 'html_entity_decode');

// set some vars
$eme_timezone = get_option('timezone_string');
if (!$eme_timezone) {
	$offset = get_option('gmt_offset');
        if ($offset>0)
                $eme_timezone = "+$offset";
        elseif ($offset<0)
                $eme_timezone = "$offset";
        else
                $eme_timezone = "+0";
}
$eme_wp_date_format = get_option('date_format');
$eme_wp_time_format = get_option('time_format');

// the next is executed on activation/deactivation of EME, so as to set the rewriterules correctly
function eme_flushRules() {
   global $wp_rewrite;
   $wp_rewrite->flush_rules();
}

// Adding a new rule
function eme_insertMyRewriteRules($rules) {
   // using pagename as param to index.php causes rewrite troubles if the page is a subpage of another
   // luckily for us we have the page id, and this works ok
   $events_page_id = eme_get_events_page_id();
   $events_prefix=eme_permalink_convert(get_option('eme_permalink_events_prefix'));
   $locations_prefix=eme_permalink_convert(get_option('eme_permalink_locations_prefix'));
   $newrules = array();
   $newrules['(.*/)?'.$events_prefix.'(\d{4})-(\d{2})-(\d{2})/c(.*)'] = 'index.php?page_id='.$events_page_id.'&calendar_day=$matches[2]-$matches[3]-$matches[4]'.'&eme_event_cat=$matches[5]';
   $newrules['(.*/)?'.$events_prefix.'(\d{4})-(\d{2})-(\d{2})/?$'] = 'index.php?page_id='.$events_page_id.'&calendar_day=$matches[2]-$matches[3]-$matches[4]';
   $newrules['(.*/)?'.$events_prefix.'(\d+)/.*'] = 'index.php?page_id='.$events_page_id.'&event_id=$matches[2]';
   $newrules['(.*/)?'.$events_prefix.'p/(.*)'] = 'index.php?page_id='.$events_page_id.'&eme_pmt_rndid=$matches[2]';
   $newrules['(.*/)?'.$events_prefix.'town/(.*)'] = 'index.php?page_id='.$events_page_id.'&eme_city=$matches[2]';
   $newrules['(.*/)?'.$events_prefix.'city/(.*)'] = 'index.php?page_id='.$events_page_id.'&eme_city=$matches[2]';
   $newrules['(.*/)?'.$events_prefix.'country/(.*)'] = 'index.php?page_id='.$events_page_id.'&eme_country=$matches[2]';
   $newrules['(.*/)?'.$events_prefix.'cat/(.*)'] = 'index.php?page_id='.$events_page_id.'&eme_event_cat=$matches[2]';
   $newrules['(.*/)?'.$events_prefix.'(.*)'] = 'index.php?page_id='.$events_page_id.'&event_id=$matches[2]';
   $newrules['(.*/)?'.$locations_prefix.'(\d+)/.*'] = 'index.php?page_id='.$events_page_id.'&location_id=$matches[2]';
   $newrules['(.*/)?'.$locations_prefix.'(.*)'] = 'index.php?page_id='.$events_page_id.'&location_id=$matches[2]';
   return $newrules + $rules;
}
add_filter('rewrite_rules_array','eme_insertMyRewriteRules');

// Adding the id var so that WP recognizes it
function eme_insertMyRewriteQueryVars($vars) {
    array_push($vars, 'event_id');
    array_push($vars, 'location_id');
    array_push($vars, 'membership_id');
    array_push($vars, 'calendar_day');
    array_push($vars, 'eme_city');
    array_push($vars, 'eme_country');
    array_push($vars, 'eme_event_cat');
    // a bit cryptic for the booking id
    array_push($vars, 'eme_pmt_rndid');
    // for the payment result
    array_push($vars, 'eme_pmt_result');
    // for attendance
    array_push($vars, 'eme_check_attendance');
    // for members
    array_push($vars, 'eme_check_member');
    return $vars;
}
add_filter('query_vars','eme_insertMyRewriteQueryVars');

// INCLUDES
// We let the includes happen at the end, so all init-code is done
// (like eg. the load_textdomain). Some includes do stuff based on _GET
// so they need the correct info before doing stuff
require_once("eme_options.php");
require_once("eme_functions.php");
require_once("eme_filters.php");
require_once("eme_events.php");
require_once("eme_calendar.php");
require_once("eme_widgets.php");
require_once("eme_rsvp.php");
require_once("eme_locations.php"); 
require_once("eme_people.php");
require_once("eme_recurrence.php");
require_once("eme_UI_helpers.php");
require_once("eme_categories.php");
require_once("eme_holidays.php");
require_once("eme_templates.php");
require_once("eme_attributes.php");
require_once("eme_ical.php");
require_once("eme_cleanup.php");
require_once("eme_cron.php");
require_once("eme_formfields.php");
require_once("eme_shortcodes.php");
require_once("eme_actions.php");
require_once("eme_payments.php");
require_once("eme_discounts.php");
require_once("eme_members.php");
require_once("eme_mailer.php") ;
require_once("eme_countries.php") ;
require_once("eme_gdpr.php") ;

require_once("ExpressiveDate.php");

$eme_db_time_diff = eme_get_db_time_diff();

function eme_install($networkwide) {
   global $wpdb;
   if (function_exists('is_multisite') && is_multisite()) {
      // check if it is a network activation - if so, run the activation function for each blog id
      if ($networkwide) {
         //$old_blog = $wpdb->blogid;
         // Get all blog ids
         $blogids = $wpdb->get_col("SELECT blog_id FROM ".$wpdb->blogs);
         foreach ($blogids as $blog_id) {
            switch_to_blog($blog_id);
            _eme_install();
            restore_current_blog();
         }
         //switch_to_blog($old_blog);
         return;
      }  
   } 
   // executed if no network activation
   _eme_install();     
}

// the private function; for activation
function _eme_install() {
   global $eme_timezone;
   eme_add_options();

   $db_version = intval(get_option('eme_version'));
   if ($db_version > EME_DB_VERSION) {
	   update_option('eme_version', EME_DB_VERSION); 
	   return;
   }
   if ($db_version == EME_DB_VERSION) {
	   return;
   }
   eme_update_options($db_version);

   // Create events page if necessary
   $events_page_id = eme_get_events_page_id();
   if ($events_page_id) {
      if (!get_page($events_page_id))
         eme_create_events_page(); 
   } else {
      eme_create_events_page(); 
   }

   eme_create_tables();

   $eme_date_obj= new ExpressiveDate(null,$eme_timezone);
   $timestamp=$eme_date_obj->addOneDay()->setHour(0)->setMinute(0)->setSecond(0)->getTimestamp();

   // some cron we want
   if (wp_next_scheduled('eme_cron_member_daily_actions')) {
	   wp_clear_scheduled_hook('eme_cron_member_daily_actions');
   }
   wp_schedule_event($timestamp, 'daily', 'eme_cron_member_daily_actions');
   wp_schedule_event($timestamp, 'daily', 'eme_cron_gdpr_daily_actions');
   // remove old daily schedule of cleanup_captcha and set to hourly
   if (wp_next_scheduled ( 'eme_cron_cleanup_captcha' )) {
	   wp_clear_scheduled_hook('eme_cron_cleanup_captcha');
   }
   // now set the hourly schedule
   wp_schedule_event(time(), 'hourly', 'eme_cron_cleanup_captcha');

   // SEO rewrite rules
   eme_flushRules();
   
   // now set the version correct
   update_option('eme_version', EME_DB_VERSION); 
}

function eme_uninstall($networkwide) {
   global $wpdb;

   if (function_exists('is_multisite') && is_multisite()) {
      // check if it is a network activation - if so, run the activation function for each blog id
      if ($networkwide) {
         $old_blog = $wpdb->blogid;
         // Get all blog ids
         $blogids = $wpdb->get_col("SELECT blog_id FROM ".$wpdb->blogs);
         foreach ($blogids as $blog_id) {
            switch_to_blog($blog_id);
            _eme_uninstall();
         }
         switch_to_blog($old_blog);
         return;
      }  
   } 
   // executed if no network activation
   _eme_uninstall();
}

function _eme_uninstall($force_drop=0) {
   $drop_data = get_option('eme_uninstall_drop_data');
   $drop_settings = get_option('eme_uninstall_drop_settings');

   if (wp_next_scheduled('eme_cron_cleanup_unpaid')) 
      wp_clear_scheduled_hook('eme_cron_cleanup_unpaid');
   if (wp_next_scheduled('eme_cron_reminder_unpaid')) 
      wp_clear_scheduled_hook('eme_cron_reminder_unpaid');
   if (wp_next_scheduled('eme_cron_send_queued')) 
      wp_clear_scheduled_hook('eme_cron_send_queued');
   if (wp_next_scheduled('eme_cron_member_daily_actions')) 
      wp_clear_scheduled_hook('eme_cron_member_daily_actions');
   if (wp_next_scheduled('eme_cron_cleanup_captcha')) 
      wp_clear_scheduled_hook('eme_cron_cleanup_captcha');

   if ($drop_data || $force_drop) {
      eme_drop_table(EVENTS_TBNAME);
      eme_drop_table(RECURRENCE_TBNAME);
      eme_drop_table(LOCATIONS_TBNAME);
      eme_drop_table(BOOKINGS_TBNAME);
      eme_drop_table(PEOPLE_TBNAME);
      eme_drop_table(GROUPS_TBNAME);
      eme_drop_table(USERGROUPS_TBNAME);
      eme_drop_table(CATEGORIES_TBNAME);
      eme_drop_table(HOLIDAYS_TBNAME);
      eme_drop_table(TEMPLATES_TBNAME);
      eme_drop_table(FORMFIELDS_TBNAME);
      eme_drop_table(FIELDTYPES_TBNAME);
      eme_drop_table(ANSWERS_TBNAME);
      eme_drop_table(EVENTS_CF_TBNAME);
      eme_drop_table(LOCATIONS_CF_TBNAME);
      eme_drop_table(PAYMENTS_TBNAME);
      eme_drop_table(DISCOUNTS_TBNAME);
      eme_drop_table(DISCOUNTGROUPS_TBNAME);
      eme_drop_table(MQUEUE_TBNAME);
      eme_drop_table(MAILINGS_TBNAME);
      eme_drop_table(MEMBERS_TBNAME);
      eme_drop_table(MEMBERSHIPS_TBNAME);
      eme_drop_table(MEMBERSHIPS_CF_TBNAME);
      eme_drop_table(COUNTRIES_TBNAME);
      eme_drop_table(STATES_TBNAME);
   }
   if ($drop_settings || $force_drop) {
      eme_delete_events_page();
      eme_options_delete();
      eme_metabox_options_delete();
   }
   if ($drop_data && !$drop_settings) {
      delete_option('eme_version');
   }

    // SEO rewrite rules
    eme_flushRules();
}

function eme_new_blog($blog_id, $user_id, $domain, $path, $site_id, $meta ) {
   global $wpdb;
 
   if (is_plugin_active_for_network(plugin_basename( __FILE__ ))) {
      $old_blog = $wpdb->blogid;
      switch_to_blog($blog_id);
      _eme_install();
      switch_to_blog($old_blog);
   }
}

function eme_create_tables() {
   global $wpdb;
   // Creates the events table if necessary
   require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
   $charset="";
   $collate="";
   if ( $wpdb->has_cap('collation') ) {
      if ( ! empty($wpdb->charset) )
         $charset = "DEFAULT CHARACTER SET $wpdb->charset";
      if ( ! empty($wpdb->collate) )
         $collate = "COLLATE $wpdb->collate";
   }
   $eme_db_version = get_option('eme_version');
   // db_version returns incorrect info
   // $mysql_version  = $wpdb->db_version();
   //$mysql_version  = $wpdb->get_var("SELECT VERSION();");
   //$mysql_version = preg_replace( '/[^0-9.].*/', '', $mysql_version);
   //$mysql_old = version_compare( $mysql_version, "5.6", '<' );

   eme_create_events_table($charset,$collate,$eme_db_version);
   eme_create_events_cf_table($charset,$collate,$eme_db_version);
   eme_create_recurrence_table($charset,$collate,$eme_db_version);
   eme_create_locations_table($charset,$collate,$eme_db_version);
   eme_create_locations_cf_table($charset,$collate,$eme_db_version);
   eme_create_bookings_table($charset,$collate,$eme_db_version);
   eme_create_people_table($charset,$collate,$eme_db_version);
   eme_create_members_table($charset,$collate,$eme_db_version);
   eme_create_memberships_cf_table($charset,$collate,$eme_db_version);
   eme_create_categories_table($charset,$collate,$eme_db_version);
   eme_create_holidays_table($charset,$collate,$eme_db_version);
   eme_create_templates_table($charset,$collate,$eme_db_version);
   eme_create_formfields_table($charset,$collate,$eme_db_version);
   eme_create_answers_table($charset,$collate,$eme_db_version);
   eme_create_payments_table($charset,$collate,$eme_db_version);
   eme_create_discounts_table($charset,$collate,$eme_db_version);
   eme_create_discountgroups_table($charset,$collate,$eme_db_version);
   eme_create_mqueue_table($charset,$collate,$eme_db_version);
   eme_create_countries_table($charset,$collate,$eme_db_version);
   eme_create_states_table($charset,$collate,$eme_db_version);
}

function eme_create_events_table($charset,$collate,$db_version) {
   global $wpdb, $eme_timezone;
   
   $table_name = $wpdb->prefix.EVENTS_TBNAME;
   
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";
   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      // Creating the events table
      $sql = "CREATE TABLE ".$table_name." (
         event_id mediumint(9) NOT NULL AUTO_INCREMENT,
         event_status mediumint(9) DEFAULT 1,
         event_author mediumint(9) DEFAULT 0,
         event_name text NOT NULL,
         event_slug text,
         event_url text,
         event_start_time time NOT NULL,
         event_end_time time NOT NULL,
         event_start_date date NOT NULL,
         event_end_date date DEFAULT NULL, 
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         event_notes longtext DEFAULT NULL,
         event_rsvp bool DEFAULT 0,
         use_paypal bool DEFAULT 0,
         use_2co bool DEFAULT 0,
         use_webmoney bool DEFAULT 0,
         use_fdgg bool DEFAULT 0,
         use_mollie bool DEFAULT 0,
         use_sagepay bool DEFAULT 0,
         price text,
         currency text,
         rsvp_number_days tinyint unsigned DEFAULT 0,
         rsvp_number_hours tinyint unsigned DEFAULT 0,
         event_seats text,
         event_contactperson_id mediumint(9) DEFAULT 0,
         location_id mediumint(9) DEFAULT 0,
         recurrence_id mediumint(9) DEFAULT 0,
         event_category_ids text,
         event_attributes text, 
         event_properties text, 
         event_page_title_format text, 
         event_single_event_format text, 
         event_contactperson_email_body text, 
         event_respondent_email_body text, 
         event_registration_recorded_ok_html text, 
         event_registration_pending_email_body text, 
         event_registration_updated_email_body text, 
         event_registration_cancelled_email_body text, 
         event_registration_paid_email_body text, 
         event_registration_trashed_email_body text, 
         event_registration_form_format text, 
         event_cancel_form_format text, 
         registration_requires_approval bool DEFAULT 0,
         registration_wp_users_only bool DEFAULT 0,
         event_image_url text,
         event_image_id mediumint(9) DEFAULT 0,
         event_external_ref text, 
         UNIQUE KEY (event_id)
         ) $charset $collate;";
      
      maybe_create_table($table_name,$sql);
      // insert a few events in the new table
      // get the current timestamp into an array
      $eme_date_obj=new ExpressiveDate(null,$eme_timezone);
      $eme_date_obj->addDays(7);
      $in_one_week = $eme_date_obj->getDate();
      $eme_date_obj->minusDays(7);
      $eme_date_obj->addWeeks(4);
      $in_four_weeks = $eme_date_obj->getDate();
      $eme_date_obj->minusWeeks(4);
      $eme_date_obj->addOneYear();
      $in_one_year = $eme_date_obj->getDate();
      
      $wpdb->query("INSERT INTO ".$table_name." (event_name, event_start_date, event_start_time, event_end_date, event_end_time, location_id)
            VALUES ('Orality in James Joyce Conference', '$in_one_week', '16:00:00', '$in_one_week', '18:00:00', 1)");
      $wpdb->query("INSERT INTO ".$table_name." (event_name, event_start_date, event_start_time, event_end_date, event_end_time, location_id)
            VALUES ('Traditional music session', '$in_four_weeks', '20:00:00', '$in_four_weeks','22:00:00', 2)");
      $wpdb->query("INSERT INTO ".$table_name." (event_name, event_start_date, event_start_time, event_end_date, event_end_time, location_id)
               VALUES ('6 Nations, Italy VS Ireland', '$in_one_year','22:00:00', '$in_one_year','24:00:00', 3)");
   } else {
      // eventual maybe_add_column() for later versions
      maybe_add_column($table_name, 'event_status', "alter table $table_name add event_status mediumint(9) DEFAULT 1;"); 
      maybe_add_column($table_name, 'event_start_date', "alter table $table_name add event_start_date date NOT NULL;"); 
      maybe_add_column($table_name, 'event_end_date', "alter table $table_name add event_end_date date NULL;");
      maybe_add_column($table_name, 'event_start_time', "alter table $table_name add event_start_time time NOT NULL;"); 
      maybe_add_column($table_name, 'event_end_time', "alter table $table_name add event_end_time time NOT NULL;"); 
      maybe_add_column($table_name, 'event_rsvp', "alter table $table_name add event_rsvp bool DEFAULT 0;");
      maybe_add_column($table_name, 'use_paypal', "alter table $table_name add use_paypal bool DEFAULT 0;");
      maybe_add_column($table_name, 'use_2co', "alter table $table_name add use_2co bool DEFAULT 0;");
      maybe_add_column($table_name, 'use_webmoney', "alter table $table_name add use_webmoney bool DEFAULT 0;");
      maybe_add_column($table_name, 'use_fdgg', "alter table $table_name add use_fdgg bool DEFAULT 0;");
      maybe_add_column($table_name, 'use_mollie', "alter table $table_name add use_mollie bool DEFAULT 0;");
      maybe_add_column($table_name, 'use_sagepay', "alter table $table_name add use_sagepay bool DEFAULT 0;");
      maybe_add_column($table_name, 'rsvp_number_days', "alter table $table_name add rsvp_number_days tinyint DEFAULT 0;");
      maybe_add_column($table_name, 'rsvp_number_hours', "alter table $table_name add rsvp_number_hours tinyint DEFAULT 0;");
      maybe_add_column($table_name, 'price', "alter table $table_name add price text;");
      maybe_add_column($table_name, 'currency', "alter table $table_name add currency text;");
      maybe_add_column($table_name, 'event_seats', "alter table $table_name add event_seats text;");
      maybe_add_column($table_name, 'location_id', "alter table $table_name add location_id mediumint(9) DEFAULT 0;");
      maybe_add_column($table_name, 'recurrence_id', "alter table $table_name add recurrence_id mediumint(9) DEFAULT 0;"); 
      maybe_add_column($table_name, 'event_contactperson_id', "alter table $table_name add event_contactperson_id mediumint(9) DEFAULT 0;");
      maybe_add_column($table_name, 'event_attributes', "alter table $table_name add event_attributes text;"); 
      maybe_add_column($table_name, 'event_properties', "alter table $table_name add event_properties text;"); 
      maybe_add_column($table_name, 'event_url', "alter table $table_name add event_url text;"); 
      maybe_add_column($table_name, 'event_slug', "alter table $table_name add event_slug text;"); 
      maybe_add_column($table_name, 'event_category_ids', "alter table $table_name add event_category_ids text;"); 
      maybe_add_column($table_name, 'event_page_title_format', "alter table $table_name add event_page_title_format text;"); 
      maybe_add_column($table_name, 'event_single_event_format', "alter table $table_name add event_single_event_format text;"); 
      maybe_add_column($table_name, 'event_contactperson_email_body', "alter table $table_name add event_contactperson_email_body text;"); 
      maybe_add_column($table_name, 'event_respondent_email_body', "alter table $table_name add event_respondent_email_body text;"); 
      maybe_add_column($table_name, 'event_registration_pending_email_body', "alter table $table_name add event_registration_pending_email_body text;"); 
      maybe_add_column($table_name, 'event_registration_updated_email_body', "alter table $table_name add event_registration_updated_email_body text;"); 
      maybe_add_column($table_name, 'event_registration_cancelled_email_body', "alter table $table_name add event_registration_cancelled_email_body text;"); 
      maybe_add_column($table_name, 'event_registration_paid_email_body', "alter table $table_name add event_registration_paid_email_body text;"); 
      maybe_add_column($table_name, 'event_registration_recorded_ok_html', "alter table $table_name add event_registration_recorded_ok_html text;"); 
      maybe_add_column($table_name, 'registration_requires_approval', "alter table $table_name add registration_requires_approval bool DEFAULT 0;"); 
      $registration_wp_users_only=get_option('eme_rsvp_registered_users_only');
      maybe_add_column($table_name, 'registration_wp_users_only', "alter table $table_name add registration_wp_users_only bool DEFAULT $registration_wp_users_only;"); 
      maybe_add_column($table_name, 'event_author', "alter table $table_name add event_author mediumint(9) DEFAULT 0;"); 
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts"); 
      eme_maybe_drop_column($table_name, 'creation_date_gmt');
      eme_maybe_drop_column($table_name, 'modif_date_gmt');
      maybe_add_column($table_name, 'event_registration_form_format', "alter table $table_name add event_registration_form_format text;"); 
      maybe_add_column($table_name, 'event_cancel_form_format', "alter table $table_name add event_cancel_form_format text;"); 
      maybe_add_column($table_name, 'event_image_url', "alter table $table_name add event_image_url text;"); 
      maybe_add_column($table_name, 'event_image_id', "alter table $table_name add event_image_id mediumint(9) DEFAULT 0;"); 
      maybe_add_column($table_name, 'event_external_ref', "alter table $table_name add event_external_ref text;"); 
      if ($db_version<3) {
         $wpdb->query("ALTER TABLE $table_name MODIFY event_name text;");
         $wpdb->query("ALTER TABLE $table_name MODIFY event_notes longtext;");
      }
      if ($db_version<4) {
         $wpdb->query("ALTER TABLE $table_name CHANGE event_category_id event_category_ids text;");
         $wpdb->query("ALTER TABLE $table_name MODIFY event_author mediumint(9) DEFAULT 0;");
         $wpdb->query("ALTER TABLE $table_name MODIFY event_contactperson_id mediumint(9) DEFAULT 0;");
         $wpdb->query("ALTER TABLE $table_name MODIFY event_seats mediumint(9) DEFAULT 0;");
         $wpdb->query("ALTER TABLE $table_name MODIFY location_id mediumint(9) DEFAULT 0;");
         $wpdb->query("ALTER TABLE $table_name MODIFY recurrence_id mediumint(9) DEFAULT 0;");
         $wpdb->query("ALTER TABLE $table_name MODIFY event_rsvp bool DEFAULT 0;");
      }
      if ($db_version<5) {
         $wpdb->query("ALTER TABLE $table_name MODIFY event_rsvp bool DEFAULT 0;");
      }
      if ($db_version<11) {
	 if (eme_column_exists($table_name, 'event_creator_id')) {
		 eme_maybe_drop_column($table_name,'event_author');
		 $wpdb->query("ALTER TABLE $table_name CHANGE event_creator_id event_author mediumint(9) DEFAULT 0;");
	 }
	 // in case event_creator_id didn't exist ...
         maybe_add_column($table_name, 'event_author', "alter table $table_name add event_author mediumint(9) DEFAULT 0;"); 
      }
      if ($db_version<29) {
         $wpdb->query("ALTER TABLE $table_name MODIFY price text;");
      }
      if ($db_version<33) {
         $post_table_name = $wpdb->prefix."posts";
         $wpdb->query("UPDATE $table_name SET event_image_id = (select ID from $post_table_name where post_type = 'attachment' AND guid = $table_name.event_image_url);");
      }
      if ($db_version<38) {
         $wpdb->query("ALTER TABLE $table_name MODIFY event_seats text;");
      }
      if ($db_version<68) {
         $wpdb->query("ALTER TABLE $table_name MODIFY rsvp_number_days tinyint DEFAULT 0;");
         $wpdb->query("ALTER TABLE $table_name MODIFY rsvp_number_hours tinyint DEFAULT 0;");
      }
      if ($db_version<70) {
	 eme_maybe_drop_column($table_name,'use_google');
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
      if ($db_version<247) {
	 if (eme_column_exists($table_name,'event_registration_denied_email_body') && !eme_column_exists($table_name,'event_registration_trashed_email_body'))
		 $wpdb->query("ALTER TABLE $table_name CHANGE event_registration_denied_email_body event_registration_trashed_email_body text;");
	 maybe_add_column($table_name, 'event_registration_trashed_email_body', "alter table $table_name add event_registration_trashed_email_body text;"); 
      }
   }
}

function eme_create_recurrence_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.RECURRENCE_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      
      $sql = "CREATE TABLE ".$table_name." (
         recurrence_id mediumint(9) NOT NULL AUTO_INCREMENT,
         recurrence_start_date date NOT NULL,
         recurrence_end_date date NOT NULL,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         recurrence_interval tinyint NOT NULL, 
         recurrence_freq tinytext NOT NULL,
         recurrence_byday tinytext NOT NULL,
         recurrence_byweekno tinyint NOT NULL,
         recurrence_specific_days text,
         holidays_id mediumint(9) DEFAULT 0,
         UNIQUE KEY (recurrence_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts ;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts"); 
      eme_maybe_drop_column($table_name, 'creation_date_gmt');
      eme_maybe_drop_column($table_name, 'modif_date_gmt');
      maybe_add_column($table_name, 'recurrence_specific_days', "alter table $table_name add recurrence_specific_days text;"); 
      maybe_add_column($table_name, 'holidays_id', "alter table $table_name add holidays_id mediumint(9) DEFAULT 0;"); 
      if ($db_version<3) {
         $wpdb->query("ALTER TABLE $table_name MODIFY recurrence_byday tinytext NOT NULL ;");
      }
      if ($db_version<4) {
	 eme_maybe_drop_column($table_name,'recurrence_name');
	 eme_maybe_drop_column($table_name,'recurrence_start_time');
	 eme_maybe_drop_column($table_name,'recurrence_end_time');
	 eme_maybe_drop_column($table_name,'recurrence_notes');
	 eme_maybe_drop_column($table_name,'location_id');
	 eme_maybe_drop_column($table_name,'event_contactperson_id');
	 eme_maybe_drop_column($table_name,'event_category_id');
	 eme_maybe_drop_column($table_name,'event_page_title_format');
	 eme_maybe_drop_column($table_name,'event_single_event_format');
	 eme_maybe_drop_column($table_name,'event_contactperson_email_body');
	 eme_maybe_drop_column($table_name,'event_respondent_email_body');
	 eme_maybe_drop_column($table_name,'registration_requires_approval');
      }
      if ($db_version<13) {
         $wpdb->query("UPDATE $table_name set creation_date=NOW() where creation_date='0000-00-00 00:00:00'");
         $wpdb->query("UPDATE $table_name set modif_date=NOW() where modif_date='0000-00-00 00:00:00'");
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_locations_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.LOCATIONS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         location_id mediumint(9) NOT NULL AUTO_INCREMENT,
         location_name text NOT NULL,
         location_slug text,
         location_url text,
         location_address1 tinytext, 
         location_address2 tinytext, 
         location_city tinytext, 
         location_state tinytext, 
         location_zip tinytext, 
         location_country tinytext, 
         location_latitude tinytext,
         location_longitude tinytext,
         location_description text,
         location_author mediumint(9) DEFAULT 0,
         location_category_ids text,
         location_creation_date datetime $default_current_ts,
         location_modif_date datetime $update_current_ts,
         location_image_url text,
         location_image_id mediumint(9) DEFAULT 0,
         location_attributes text, 
         location_properties text, 
         location_external_ref text, 
         UNIQUE KEY (location_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
      
      $wpdb->query("INSERT INTO ".$table_name." (location_name, location_address1, location_city, location_latitude, location_longitude)
               VALUES ('Arts Millenium Building', 'Newcastle Road','Galway', '53.275', '-9.06532')");
      $wpdb->query("INSERT INTO ".$table_name." (location_name, location_address1, location_city, location_latitude, location_longitude)
               VALUES ('The Crane Bar', '2, Sea Road','Galway', '53.2683224', '-9.0626223')");
      $wpdb->query("INSERT INTO ".$table_name." (location_name, location_address1, location_city, location_latitude, location_longitude)
               VALUES ('Taaffes Bar', '19 Shop Street','Galway', '53.2725', '-9.05321')");
   } else {
      maybe_add_column($table_name, 'location_author', "alter table $table_name add location_author mediumint(9) DEFAULT 0;"); 
      maybe_add_column($table_name, 'location_category_ids', "alter table $table_name add location_category_ids text;"); 
      maybe_add_column($table_name, 'location_creation_date', "alter table $table_name add location_creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'location_modif_date', "alter table $table_name add location_modif_date datetime $update_current_ts;"); 
      eme_maybe_drop_column($table_name, 'location_creation_date_gmt');
      maybe_add_column($table_name, 'location_url', "alter table $table_name add location_url text;"); 
      maybe_add_column($table_name, 'location_slug', "alter table $table_name add location_slug text;"); 
      maybe_add_column($table_name, 'location_image_url', "alter table $table_name add location_image_url text;"); 
      maybe_add_column($table_name, 'location_image_id', "alter table $table_name add location_image_id mediumint(9) DEFAULT 0;"); 
      maybe_add_column($table_name, 'location_attributes', "alter table $table_name add location_attributes text;"); 
      maybe_add_column($table_name, 'location_properties', "alter table $table_name add location_properties text;"); 
      maybe_add_column($table_name, 'location_external_ref', "alter table $table_name add location_external_ref text;");    
      if ($db_version<3) {
         $wpdb->query("ALTER TABLE $table_name MODIFY location_name text NOT NULL ;");
      }
      if ($db_version<33) {
         $post_table_name = $wpdb->prefix."posts";
         $wpdb->query("UPDATE $table_name SET location_image_id = (select ID from $post_table_name where post_type = 'attachment' AND guid = $table_name.location_image_url);");
      }
      if ($db_version<110) {
         $wpdb->query("ALTER TABLE $table_name CHANGE location_address location_address1 tinytext;");
         $wpdb->query("ALTER TABLE $table_name CHANGE location_town location_city tinytext;");
         maybe_add_column($table_name, 'location_address2', "ALTER TABLE $table_name add location_address2 tinytext;"); 
         maybe_add_column($table_name, 'location_state', "ALTER TABLE $table_name add location_state tinytext;"); 
         maybe_add_column($table_name, 'location_zip', "ALTER TABLE $table_name add location_zip tinytext;"); 
         maybe_add_column($table_name, 'location_country', "ALTER TABLE $table_name add location_country tinytext;"); 
      }
      if ($db_version<183) {
         $wpdb->query("ALTER TABLE $table_name CHANGE location_latitude location_latitude tinytext;");
         $wpdb->query("ALTER TABLE $table_name CHANGE location_longitude location_longitude tinytext;");
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY location_creation_date datetime $default_current_ts;");
      }
   }
}

function eme_create_bookings_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.BOOKINGS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   // column discount: effective calculated discount value
   // columns discountid , dgroupid: pointer to discount/discout group applied
   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         booking_id mediumint(9) NOT NULL AUTO_INCREMENT,
         event_id mediumint(9) NOT NULL,
         person_id mediumint(9) NOT NULL, 
         payment_id mediumint(9) DEFAULT NULL, 
         status tinyint DEFAULT 1,
         booking_seats mediumint(9) NOT NULL,
         booking_seats_mp varchar(250),
         booking_approved bool DEFAULT 0,
         waitinglist bool DEFAULT 0,
         booking_comment text,
         event_price text,
         extra_charge tinytext,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         payment_date datetime DEFAULT '0000-00-00 00:00:00',
         booking_paid bool DEFAULT 0,
         pg tinytext,
         pg_pid tinytext,
         reminder INT(11) DEFAULT 0,
         transfer_nbr_be97 varchar(20),
         wp_id bigint(20) unsigned DEFAULT NULL,
         lang varchar(10) DEFAULT '',
         discount tinytext,
         discountids tinytext,
         dcodes_entered tinytext,
         dcodes_used tinytext,
         dgroupid INT(11) DEFAULT 0,
         UNIQUE KEY  (booking_id),
         KEY (status)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'status', "ALTER TABLE $table_name add status tinyint DEFAULT 1;"); 
      maybe_add_column($table_name, 'booking_comment', "ALTER TABLE $table_name add booking_comment text;"); 
      maybe_add_column($table_name, 'booking_approved', "ALTER TABLE $table_name add booking_approved bool DEFAULT 0;"); 
      maybe_add_column($table_name, 'waitinglist', "ALTER TABLE $table_name add waitinglist bool DEFAULT 0;"); 
      maybe_add_column($table_name, 'payment_date', "alter table $table_name add payment_date datetime DEFAULT '0000-00-00 00:00:00';"); 
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      eme_maybe_drop_column($table_name, 'creation_date_gmt');
      eme_maybe_drop_column($table_name,'modif_date_gmt');
      maybe_add_column($table_name, 'transfer_nbr_be97', "alter table $table_name add transfer_nbr_be97 varchar(20);"); 
      maybe_add_column($table_name, 'booking_seats_mp', "alter table $table_name add booking_seats_mp varchar(250);"); 
      maybe_add_column($table_name, 'wp_id', "ALTER TABLE $table_name add wp_id bigint(20) unsigned DEFAULT NULL;"); 
      eme_maybe_drop_column($table_name,'ip');
      maybe_add_column($table_name, 'lang', "ALTER TABLE $table_name add lang varchar(10) DEFAULT '';"); 
      maybe_add_column($table_name, 'extra_charge', "alter table $table_name add extra_charge tinytext;"); 
      maybe_add_column($table_name, 'discount', "alter table $table_name add discount tinytext;"); 
      maybe_add_column($table_name, 'dcodes_entered', "alter table $table_name add dcodes_entered tinytext ;"); 
      maybe_add_column($table_name, 'dcodes_used', "alter table $table_name add dcodes_used tinytext ;"); 
      maybe_add_column($table_name, 'dgroupid', "alter table $table_name add dgroupid INT(11) DEFAULT 0;"); 
      maybe_add_column($table_name, 'reminder', "alter table $table_name add reminder INT(11) DEFAULT 0;"); 
      if (eme_column_exists($table_name, 'discountid'))
         $wpdb->query("ALTER TABLE $table_name CHANGE discountid discountids tinytext;");
      else
	 maybe_add_column($table_name, 'discountids', "alter table $table_name add discountids tinytext;"); 
      maybe_add_column($table_name, 'pg', "alter table $table_name add pg tinytext;"); 
      maybe_add_column($table_name, 'pg_pid', "alter table $table_name add pg_pid tinytext;"); 

      if ($db_version<3) {
         $wpdb->query("ALTER TABLE $table_name MODIFY event_id mediumint(9) NOT NULL;");
         $wpdb->query("ALTER TABLE $table_name MODIFY person_id mediumint(9) NOT NULL;");
         $wpdb->query("ALTER TABLE $table_name MODIFY booking_seats mediumint(9) NOT NULL;");
      }
      if ($db_version<47) {
         $people_table_name = $wpdb->prefix.PEOPLE_TBNAME;
         $wpdb->query("update $table_name a JOIN $people_table_name b on (a.person_id = b.person_id)  set a.wp_id=b.wp_id;");
      }
      if ($db_version<92) {
         maybe_add_column($table_name, 'payment_id', "ALTER TABLE $table_name add payment_id mediumint(9) DEFAULT NULL;"); 
         $payment_table_name = $wpdb->prefix.PAYMENTS_TBNAME;
         $sql = "SELECT id,booking_ids from $payment_table_name";

         $rows = $wpdb->get_results ( $sql, ARRAY_A );
         if ($rows!==false && !empty($rows)) {
            foreach ( $rows as $row ) {
               $booking_ids = explode(',', $row['booking_ids']);
               if (is_array($booking_ids) && count($booking_ids)>0) {
                  foreach ($booking_ids as $booking_id) {
                     $sql = $wpdb->prepare("UPDATE $table_name SET payment_id=%d WHERE booking_id=%d",$row['id'],$booking_id);
                     $wpdb->query($sql);
                  }
               }
            }
	    eme_maybe_drop_column($payment_table_name,'booking_ids');
         }
      }
      if ($db_version<107) {
         $wpdb->query("ALTER TABLE $table_name CHANGE booking_payed booking_paid bool DEFAULT 0;");
      }
      if ($db_version<208) {
	     if (eme_column_exists($table_name, 'booking_price')) {
		 $wpdb->query("ALTER TABLE $table_name CHANGE booking_price event_price text;");
	     } else {
		 maybe_add_column($table_name, 'event_price', "alter table $table_name add event_price text;"); 
	     }
      }

      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts;");
         if (eme_column_exists($table_name, 'modif_date'))
	      $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_people_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.PEOPLE_TBNAME;
   $grouptable_name = $wpdb->prefix.GROUPS_TBNAME;
   $usergrouptable_name = $wpdb->prefix.USERGROUPS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         person_id mediumint(9) NOT NULL AUTO_INCREMENT,
         lastname tinytext, 
         firstname tinytext, 
         email tinytext NOT NULL,
         status tinyint DEFAULT 1,
         phone tinytext,
         wp_id bigint(20) unsigned DEFAULT NULL,
         address1 tinytext, 
         address2 tinytext, 
         city tinytext, 
         zip tinytext, 
         state tinytext, 
         country tinytext, 
         state_code tinytext,
         country_code tinytext,
         lang varchar(10) DEFAULT '',
         massmail bool DEFAULT 1,
         gdpr bool DEFAULT 0,
         properties text,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         gdpr_date date,
         UNIQUE KEY (person_id),
         KEY (status)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'gdpr', "ALTER TABLE $table_name add gdpr bool DEFAULT 0;"); 
      maybe_add_column($table_name, 'gdpr_date', "ALTER TABLE $table_name add gdpr_date date;"); 
      maybe_add_column($table_name, 'status', "ALTER TABLE $table_name add status tinyint DEFAULT 1;"); 
      maybe_add_column($table_name, 'state_code', "ALTER TABLE $table_name add state_code tinytext;"); 
      maybe_add_column($table_name, 'country_code', "ALTER TABLE $table_name add country_code tinytext;"); 
      maybe_add_column($table_name, 'wp_id', "ALTER TABLE $table_name add wp_id bigint(20) unsigned DEFAULT NULL;"); 
      maybe_add_column($table_name, 'firstname', "ALTER TABLE $table_name add firstname tinytext;"); 
      maybe_add_column($table_name, 'address1', "ALTER TABLE $table_name add address1 tinytext;"); 
      maybe_add_column($table_name, 'address2', "ALTER TABLE $table_name add address2 tinytext;"); 
      maybe_add_column($table_name, 'city', "ALTER TABLE $table_name add city tinytext;"); 
      maybe_add_column($table_name, 'state', "ALTER TABLE $table_name add state tinytext;"); 
      maybe_add_column($table_name, 'zip', "ALTER TABLE $table_name add zip tinytext;"); 
      maybe_add_column($table_name, 'country', "ALTER TABLE $table_name add country tinytext;"); 
      maybe_add_column($table_name, 'lang', "ALTER TABLE $table_name add lang varchar(10) DEFAULT '';"); 
      maybe_add_column($table_name, 'massmail', "ALTER TABLE $table_name add massmail bool DEFAULT 1;"); 
      maybe_add_column($table_name, 'properties', "ALTER TABLE $table_name add properties text;"); 
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      if ($db_version<10) {
         $wpdb->query("ALTER TABLE $table_name MODIFY person_phone tinytext DEFAULT 0;");
      }
      if ($db_version<78) {
         $wpdb->query("ALTER TABLE $table_name CHANGE person_phone phone tinytext DEFAULT NULL;");
         $wpdb->query("ALTER TABLE $table_name CHANGE person_name lastname tinytext NOT NULL;");
         $wpdb->query("ALTER TABLE $table_name CHANGE person_email email tinytext NOT NULL;");
      }
      if ($db_version<163) {
	 eme_maybe_drop_column($table_name,'image_id');
      }
      if ($db_version<204) {
         $wpdb->query("ALTER TABLE ".$table_name." ADD KEY (status)");
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
   if($wpdb->get_var("SHOW TABLES LIKE '$grouptable_name'") != $grouptable_name) {
      $sql = "CREATE TABLE ".$grouptable_name." (
         group_id int(11) NOT NULL auto_increment,
         name varchar(50) DEFAULT NULL,
         description tinytext,
         type tinytext,
         mail_only bool DEFAULT 0,
         stored_sql text,
         UNIQUE KEY  (group_id)
         ) $charset $collate;";
      maybe_create_table($grouptable_name,$sql);
   } else {
      maybe_add_column($grouptable_name, 'type', "ALTER TABLE $grouptable_name add type tinytext;"); 
      maybe_add_column($grouptable_name, 'stored_sql', "ALTER TABLE $grouptable_name add stored_sql text;"); 
      maybe_add_column($grouptable_name, 'mail_only', "ALTER TABLE $grouptable_name add mail_only bool DEFAULT 0;"); 
      if ($db_version<175) {
         $wpdb->query("UPDATE $grouptable_name SET type = 'static';");
      }
   }
   if($wpdb->get_var("SHOW TABLES LIKE '$usergrouptable_name'") != $usergrouptable_name) {
      $sql = "CREATE TABLE ".$usergrouptable_name." (
         person_id int(11),
         group_id int(11)
         ) $charset $collate;";
      maybe_create_table($usergrouptable_name,$sql);
   }
 } 

function eme_create_categories_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.CATEGORIES_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         category_id int(11) NOT NULL auto_increment,
         category_name tinytext NOT NULL,
         description text,
         category_slug text,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (category_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'category_slug', "alter table $table_name add category_slug text;"); 
      maybe_add_column($table_name, 'description', "alter table $table_name add description text;"); 
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      if ($db_version<66) {
         $categories = $wpdb->get_results("SELECT * FROM $table_name", ARRAY_A);
         foreach ($categories as $this_category) {
             $where = array();
             $fields = array();
             $where['category_id'] = $this_category['category_id'];
             $fields['category_slug'] = untrailingslashit(eme_permalink_convert($this_category['category_name']));
             $wpdb->update($table_name, $fields, $where);
         }
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_holidays_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.HOLIDAYS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         id int(11) NOT NULL auto_increment,
         name tinytext NOT NULL,
         list text NOT NULL,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
      $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
   }
}

function eme_create_templates_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.TEMPLATES_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         id int(11) NOT NULL auto_increment,
         name tinytext,
         description tinytext,
         format text NOT NULL,
         type tinytext,
         properties text,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'type', "ALTER TABLE $table_name add type tinytext;"); 
      maybe_add_column($table_name, 'properties', "ALTER TABLE $table_name add properties text;"); 
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      if ($db_version<41) {
         $wpdb->query("ALTER TABLE $table_name MODIFY format text NOT NULL;");
      }
      if ($db_version<144) {
         $wpdb->query("ALTER TABLE $table_name MODIFY type tinytext;");
         $wpdb->query("UPDATE $table_name SET type='' WHERE type IS NULL;");
      }
      if ($db_version<151) {
         maybe_add_column($table_name, 'name', "ALTER TABLE $table_name add name tinytext;"); 
         $wpdb->query("UPDATE $table_name SET name = description;");
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_formfields_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.FORMFIELDS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         field_id int(11) NOT NULL auto_increment,
         field_type tinytext NOT NULL,
         field_name tinytext NOT NULL,
         field_values text NOT NULL,
         admin_values text,
         field_tags text,
         admin_tags text,
         field_attributes tinytext,
         field_purpose tinytext,
         field_condition tinytext,
         field_required bool DEFAULT 0,
         export bool DEFAULT 0,
         extra_charge bool DEFAULT 0,
         searchable bool DEFAULT 0,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (field_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      maybe_add_column($table_name, 'field_tags', "ALTER TABLE $table_name add field_tags text;"); 
      maybe_add_column($table_name, 'admin_values', "ALTER TABLE $table_name add admin_values text;"); 
      maybe_add_column($table_name, 'admin_tags', "ALTER TABLE $table_name add admin_tags text;"); 
      maybe_add_column($table_name, 'field_attributes', "ALTER TABLE $table_name add field_attributes tinytext DEFAULT NULL;"); 
      maybe_add_column($table_name, 'extra_charge', "alter table $table_name add extra_charge bool DEFAULT 0;"); 
      maybe_add_column($table_name, 'field_condition', "alter table $table_name add field_condition tinytext;"); 
      maybe_add_column($table_name, 'field_required', "alter table $table_name add field_required bool DEFAULT 0;"); 
      maybe_add_column($table_name, 'export', "alter table $table_name add export bool DEFAULT 0;"); 
      maybe_add_column($table_name, 'searchable', "alter table $table_name add searchable bool DEFAULT 0;"); 
      maybe_add_column($table_name, 'field_purpose', "alter table $table_name add field_purpose tinytext;"); 
      if ($db_version<104) {
	 eme_maybe_drop_column($table_name,'field_pattern');
      }
      if ($db_version<154) {
         $wpdb->query("ALTER TABLE $table_name CHANGE field_info field_values text NOT NULL;");
      }
      if ($db_version<54) {
         $wpdb->query("UPDATE ".$table_name." SET field_tags=field_values");
      }
      if ($db_version<166) {
         $wpdb->query("ALTER TABLE $table_name CHANGE field_type old_type mediumint(9);");
	 maybe_add_column($table_name, 'field_type', "alter table $table_name add field_type tinytext NOT NULL;"); 
         $wpdb->query("UPDATE ".$table_name." SET field_type='text' WHERE old_type=1;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='dropdown' WHERE old_type=2;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='textarea' WHERE old_type=3;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='radiobox' WHERE old_type=4;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='radiobox_vertical' WHERE old_type=5;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='checkbox' WHERE old_type=6;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='checkbox_vertical' WHERE old_type=7;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='date' WHERE old_type=8;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='date_js' WHERE old_type=9;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='dropdown_multi' WHERE old_type=10;");
	 eme_drop_table($wpdb->prefix.FIELDTYPES_TBNAME);
      }
      // the next one is to fix older issues
      if ($db_version<193) {
         $wpdb->query("UPDATE ".$table_name." SET field_type='radiobox_vertical' WHERE old_type=5;");
         $wpdb->query("UPDATE ".$table_name." SET field_type='checkbox_vertical' WHERE old_type=7;");
	 eme_drop_table($wpdb->prefix.FIELDTYPES_TBNAME);
      }
      if ($db_version<214) {
         $wpdb->query("UPDATE ".$table_name." SET field_purpose='generic' WHERE field_purpose IS NULL;");
      }
      if ($db_version<215) {
	 eme_maybe_drop_column($table_name,'old_type');
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_events_cf_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.EVENTS_CF_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         answer_id int(11) NOT NULL auto_increment,
         event_id mediumint(9) DEFAULT 0,
         field_id int(11) DEFAULT 0,
         answer text NOT NULL,
         UNIQUE KEY  (answer_id),
         KEY  (event_id),
         KEY  (field_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   }
}

function eme_create_locations_cf_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.LOCATIONS_CF_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";

   if ($db_version<216) {
	  eme_drop_table(LOCATIONS_CF_TBNAME);
   }
   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         answer_id int(11) NOT NULL auto_increment,
         location_id mediumint(9) DEFAULT 0,
         field_id int(11) DEFAULT 0,
         answer text NOT NULL,
         UNIQUE KEY  (answer_id),
         KEY  (location_id),
         KEY  (field_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   }
}

function eme_create_answers_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.ANSWERS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         answer_id int(11) NOT NULL auto_increment,
         booking_id mediumint(9) DEFAULT 0,
         person_id mediumint(9) DEFAULT 0,
         member_id mediumint(9) DEFAULT 0,
         field_id int(11) DEFAULT 0,
         answer text NOT NULL,
         grouping int(11) DEFAULT 0,
         occurence int(11) DEFAULT 0,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (answer_id),
         KEY  (booking_id),
         KEY  (person_id),
         KEY  (member_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      if ($db_version==23) {
         $wpdb->query("ALTER TABLE ".$table_name." DROP PRIMARY KEY");
         $wpdb->query("ALTER TABLE ".$table_name." ADD KEY (booking_id)");
      }
      if ($db_version<112) {
         maybe_add_column($table_name, 'field_id', "ALTER TABLE $table_name add field_id INT(11) DEFAULT 0;"); 
         $formfield_table_name = $wpdb->prefix.FORMFIELDS_TBNAME;
         $res=$wpdb->query("UPDATE $table_name SET field_id = (select field_id from $formfield_table_name where field_name = $table_name.field_name LIMIT 1);");
         if ($res!==false)
		 eme_maybe_drop_column($table_name,'field_name');
      }
      if ($db_version<125) {
         maybe_add_column($table_name, 'grouping', "ALTER TABLE $table_name add grouping INT(11) DEFAULT 0;"); 
         maybe_add_column($table_name, 'occurence', "ALTER TABLE $table_name add occurence INT(11) DEFAULT 0;"); 
      }
      if ($db_version<138) {
	 $wpdb->query("ALTER TABLE $table_name MODIFY booking_id mediumint(9) DEFAULT 0;");
         maybe_add_column($table_name, 'person_id', "ALTER TABLE $table_name add person_id MEDIUMINT(9) DEFAULT 0;"); 
         $wpdb->query("ALTER TABLE ".$table_name." ADD KEY (person_id)");
      }
      if ($db_version<143) {
         maybe_add_column($table_name, 'member_id', "ALTER TABLE $table_name add member_id MEDIUMINT(9) DEFAULT 0;"); 
         $wpdb->query("ALTER TABLE ".$table_name." ADD KEY (member_id)");
      }
      if ($db_version<156) {
	 $wpdb->query("ALTER TABLE ".$table_name." ADD answer_id INT(11) PRIMARY KEY AUTO_INCREMENT;");
      }
      if ($db_version<161) {
	 $wpdb->query("ALTER TABLE $table_name CHANGE answer_id answer_id INT(11) PRIMARY KEY AUTO_INCREMENT;");
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_payments_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.PAYMENTS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         id int(11) NOT NULL auto_increment,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         random_id tinytext NOT NULL,
         member_id INT(11) DEFAULT 0,
         attend_count INT(11) DEFAULT 0,
         pg_pids text,
         UNIQUE KEY  (id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'pg_pids', "alter table $table_name add pg_pids text;"); 
      maybe_add_column($table_name, 'random_id', "alter table $table_name add random_id tinytext NOT NULL;"); 
      maybe_add_column($table_name, 'member_id', "alter table $table_name add member_id INT(11) DEFAULT 0;"); 
      maybe_add_column($table_name, 'attend_count', "alter table $table_name add attend_count INT(11) DEFAULT 0;"); 
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      eme_maybe_drop_column($table_name, 'creation_date_gmt');
      if ($db_version<80) {
         $payment_ids = $wpdb->get_col("SELECT id FROM $table_name");
         foreach ($payment_ids as $payment_id) {
            $random_id=eme_random_id();
            $sql = $wpdb->prepare("UPDATE $table_name SET random_id = %s WHERE id = %d",$random_id,$payment_id);
            $wpdb->query($sql);
         }
      }
      if ($db_version<104) {
	 eme_maybe_drop_column($table_name,'booking_ids');
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_discounts_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.DISCOUNTS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   // coupon types: 1=fixed,2=percentage,3=code (filter),4=fixed_per_seat
   // column coupon: text to be entered by booker
   // column value: the applied discount (converted in php to floating point)
   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         id int(11) NOT NULL auto_increment,
         name varchar(50) DEFAULT NULL,
         description tinytext,
         type tinyint UNSIGNED DEFAULT 0,
         coupon tinytext,
         dgroup tinytext,
         value tinytext,
         maxcount tinyint UNSIGNED DEFAULT 0,
         count tinyint UNSIGNED DEFAULT 0,
         strcase bool DEFAULT 1,
         use_per_seat bool DEFAULT 0,
         expire date DEFAULT NULL, 
         properties text,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (id),
         UNIQUE KEY  (name)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'expire', "alter table $table_name add expire date DEFAULT NULL;"); 
      maybe_add_column($table_name, 'strcase', "alter table $table_name add strcase bool DEFAULT 1;"); 
      maybe_add_column($table_name, 'use_per_seat', "alter table $table_name add use_per_seat bool DEFAULT 0;"); 
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      maybe_add_column($table_name, 'properties', "ALTER TABLE $table_name add properties text;"); 
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_discountgroups_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.DISCOUNTGROUPS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   // column maxdiscounts: max number of discounts in a group that can
   // be used, 0 for no max (this to avoid hackers from adding discount fields
   // to a form)
   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         id int(11) NOT NULL auto_increment,
         description tinytext,
         name varchar(50) DEFAULT NULL,
         maxdiscounts tinyint UNSIGNED DEFAULT 0,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (id),
         UNIQUE KEY  (name)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'description', "alter table $table_name add description tinytext;"); 
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_mqueue_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.MQUEUE_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         id int(11) NOT NULL auto_increment,
         mailing_id int(11) DEFAULT 0,
         person_id int(11) DEFAULT 0,
         member_id int(11) DEFAULT 0,
         status tinyint DEFAULT 0,
         creation_date datetime $default_current_ts,
         sent_datetime datetime NOT NULL DEFAULT '0000-00-00 00:00:00', 
         read_datetime datetime NOT NULL DEFAULT '0000-00-00 00:00:00', 
         read_count int DEFAULT 0,
         receiveremail tinytext,
         receivername tinytext,
         replytoemail tinytext,
         replytoname tinytext,
         subject tinytext,
         body text,
         random_id tinytext NOT NULL,
         error_msg tinytext,
         attachments text,
         UNIQUE KEY  (id),
         KEY  (status)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'mailing_id', "alter table $table_name add mailing_id int(11) DEFAULT 0;"); 
      maybe_add_column($table_name, 'person_id', "alter table $table_name add person_id int(11) DEFAULT 0;"); 
      maybe_add_column($table_name, 'member_id', "alter table $table_name add member_id int(11) DEFAULT 0;"); 
      maybe_add_column($table_name, 'random_id', "alter table $table_name add random_id tinytext NOT NULL;"); 
      maybe_add_column($table_name, 'read_datetime', "alter table $table_name add read_datetime datetime NOT NULL DEFAULT '0000-00-00 00:00:00';"); 
      maybe_add_column($table_name, 'read_count', "alter table $table_name add read_count int DEFAULT 0;"); 
      maybe_add_column($table_name, 'error_msg', "alter table $table_name add error_msg tinytext;"); 
      maybe_add_column($table_name, 'attachments', "alter table $table_name add attachments text;"); 
      if ($db_version<140) {
         $wpdb->query("ALTER TABLE $table_name DROP KEY is_sent");
         $wpdb->query("ALTER TABLE $table_name CHANGE is_sent state tinyint DEFAULT 0;");
	 $wpdb->query("ALTER TABLE $table_name ADD KEY (state)");
      }
      if ($db_version<153) {
         $wpdb->query("ALTER TABLE $table_name CHANGE state status tinyint DEFAULT 0;");
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
      }
   }

   $table_name = $wpdb->prefix.MAILINGS_TBNAME;
   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         id int(11) NOT NULL auto_increment,
         name varchar(50) DEFAULT NULL,
	 planned_on datetime DEFAULT '0000-00-00 00:00:00', 
         creation_date datetime $default_current_ts,
         read_count int DEFAULT 0,
         total_read_count int DEFAULT 0,
         subject tinytext,
         body text,
         replytoemail tinytext,
         replytoname tinytext,
         mail_text_html tinytext,
         status tinytext,
         stats varchar(255) DEFAULT '',
         conditions text,
         UNIQUE KEY  (id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
	   maybe_add_column($table_name, 'status', "alter table $table_name add status tinytext;"); 
	   maybe_add_column($table_name, 'stats', "alter table $table_name add stats varchar(255) DEFAULT '';"); 
	   maybe_add_column($table_name, 'replytoemail', "alter table $table_name add replytoemail tinytext;"); 
	   maybe_add_column($table_name, 'mail_text_html', "alter table $table_name add mail_text_html tinytext;"); 
	   maybe_add_column($table_name, 'replytoname', "alter table $table_name add replytoname tinytext;"); 
	   maybe_add_column($table_name, 'subject', "alter table $table_name add subject tinytext;"); 
	   maybe_add_column($table_name, 'body', "alter table $table_name add body text;"); 
	   maybe_add_column($table_name, 'conditions', "alter table $table_name add conditions text ;"); 
	   maybe_add_column($table_name, 'read_count', "alter table $table_name add read_count int DEFAULT 0;"); 
	   maybe_add_column($table_name, 'total_read_count', "alter table $table_name add total_read_count int DEFAULT 0;"); 
	   if ($db_version<176) {
		   $wpdb->query("UPDATE $table_name set status='cancelled' where cancelled=1;");
		   eme_maybe_drop_column($table_name,'cancelled');
	   }
	   if ($db_version<177) {
		   $wpdb->query("UPDATE $table_name set total_read_count=read_count");
		   eme_maybe_drop_column($table_name,'mail_count');
		   $mailings = eme_get_mailings();
		   foreach ($mailings as $mailing) {
			   $id=$mailing['id'];
			   $stats = eme_get_mailing_stats($id);
			   if ($mailing['status']=='cancelled') {
				   eme_cancel_mailing($id);
			   } elseif ($stats['planned']>0 && $stats['sent']==0) {
				   eme_mark_planned_mailing($id);
			   } elseif ($stats['planned']>0 && $stats['sent']>0) {
				   eme_mark_ongoing_mailing($id);
			   } else {
				   eme_mark_completed_mailing($id);
			   }
		   }

	   }
	   $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
   }
 
}
function eme_create_members_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.MEMBERS_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   // state contains the defined/calculated state
   // autostate indicates if the state needs to be calculated automatically
   //    or if it is set manually
   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         member_id int(11) NOT NULL auto_increment,
         membership_id int(11) DEFAULT 0,
         person_id int(11) DEFAULT 0,
         status tinyint DEFAULT 0,
         status_automatic BOOL DEFAULT 1,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         start_date date NOT NULL DEFAULT '0000-00-00', 
         end_date date NOT NULL DEFAULT '0000-00-00', 
         reminder INT(11) DEFAULT 0,
         reminder_date datetime DEFAULT '0000-00-00 00:00:00',
         transfer_nbr_be97 varchar(20),
         payment_id mediumint(9) DEFAULT NULL, 
         payment_date datetime DEFAULT '0000-00-00 00:00:00',
         paid bool DEFAULT 0,
         pg tinytext,
         pg_pid tinytext,
         extra_charge tinyint DEFAULT 0,
         discount tinytext,
         discountid INT(11) DEFAULT 0,
         dgroupid INT(11) DEFAULT 0,
         UNIQUE KEY  (member_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'transfer_nbr_be97', "alter table $table_name add transfer_nbr_be97 varchar(20);"); 
      maybe_add_column($table_name, 'discount', "alter table $table_name add discount tinytext;"); 
      maybe_add_column($table_name, 'discountid', "alter table $table_name add discountid INT(11) DEFAULT 0;"); 
      maybe_add_column($table_name, 'dgroupid', "alter table $table_name add dgroupid INT(11) DEFAULT 0;"); 
      maybe_add_column($table_name, 'reminder', "alter table $table_name add reminder INT(11) DEFAULT 0;"); 
      maybe_add_column($table_name, 'payment_id', "alter table $table_name add payment_id INT(9) DEFAULT NULL;"); 
      maybe_add_column($table_name, 'payment_date', "alter table $table_name add payment_date datetime DEFAULT '0000-00-00 00:00:00';"); 
      maybe_add_column($table_name, 'reminder_date', "alter table $table_name add reminder_date datetime DEFAULT '0000-00-00 00:00:00';"); 
      maybe_add_column($table_name, 'paid', "alter table $table_name add paid bool DEFAULT 0;"); 
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      maybe_add_column($table_name, 'pg', "alter table $table_name add pg tinytext;"); 
      maybe_add_column($table_name, 'pg_pid', "alter table $table_name add pg_pid tinytext;"); 
      if ($db_version<153) {
         $wpdb->query("ALTER TABLE $table_name CHANGE state status tinyint DEFAULT 0;");
         $wpdb->query("ALTER TABLE $table_name CHANGE state_automatic status_automatic BOOL DEFAULT 1;");
      }
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
      }
   }

   // properties: templ.id's for form, and subject/body for payment, confirm, reminder, stop templates
   //             and info concerning payment gateways
   //             and info concerning reminder days before sending reminder
   // type: fixed/rolling
   // duration_count+duration_period form a logical date format: 1 days, 2 days, 3 weeks, etc ...
   // start date: only used for type fixed
   $table_name = $wpdb->prefix.MEMBERSHIPS_TBNAME;
   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         membership_id int(11) NOT NULL auto_increment,
         name varchar(50) DEFAULT NULL,
         description tinytext,
         type varchar(50) DEFAULT NULL,
         start_date date DEFAULT '0000-00-00', 
         duration_count tinyint DEFAULT 0,
         duration_period varchar(50) DEFAULT '',
         properties text,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (membership_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_memberships_cf_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.MEMBERSHIPS_CF_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         answer_id int(11) NOT NULL auto_increment,
         membership_id mediumint(9) DEFAULT 0,
         field_id int(11) DEFAULT 0,
         answer text NOT NULL,
         UNIQUE KEY  (answer_id),
         KEY  (membership_id),
         KEY  (field_id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   }
}

function eme_create_countries_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.COUNTRIES_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         id int(11) NOT NULL auto_increment,
         alpha_2 char(2) DEFAULT NULL,
         alpha_3 char(3) DEFAULT NULL,
         num_3 char(3) DEFAULT NULL,
         name varchar(100) DEFAULT NULL,
         locale tinytext,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
      if ($db_version<246) {
         $wpdb->query("ALTER TABLE $table_name CHANGE num_3 num_3 char(3) DEFAULT NULL;");
      }
   }
}

function eme_create_states_table($charset,$collate,$db_version) {
   global $wpdb;
   $table_name = $wpdb->prefix.STATES_TBNAME;
   $default_current_ts="DEFAULT CURRENT_TIMESTAMP";
   $update_current_ts="DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP";

   if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
      $sql = "CREATE TABLE ".$table_name." (
         id int(11) NOT NULL auto_increment,
         code tinytext,
         name varchar(100) DEFAULT NULL,
         country_id int(11) DEFAULT NULL,
         creation_date datetime $default_current_ts,
         modif_date datetime $update_current_ts,
         UNIQUE KEY  (id)
         ) $charset $collate;";
      maybe_create_table($table_name,$sql);
   } else {
      maybe_add_column($table_name, 'creation_date', "alter table $table_name add creation_date datetime $default_current_ts;"); 
      maybe_add_column($table_name, 'modif_date', "alter table $table_name add modif_date datetime $update_current_ts;"); 
      if ($db_version<245) {
         $wpdb->query("ALTER TABLE $table_name MODIFY creation_date datetime $default_current_ts ;");
         $wpdb->query("ALTER TABLE $table_name MODIFY modif_date datetime $update_current_ts;");
      }
   }
}

function eme_create_events_page() {
   global $wpdb;
   $postarr = array(
      'post_title'     => wp_strip_all_tags(__('Events','events-made-easy')),
      'post_content'   => __("This page is used by Events Made Easy. Don't change it, don't use it in your menu's, don't delete it. Just make sure the EME setting called 'Events page' points to this page. EME uses this page to render any and all events, locations, bookings, maps, ... anything. If you do want to delete this page, create a new one EME can use and update the EME setting 'Events page' accordingly.",'events-made-easy'),
      'post_type'      => 'page',
      'post_status'    => 'publish',
      'comment_status' => 'closed',
      'ping_status'    => 'closed'
   );
   if ($int_post_id = wp_insert_post($postarr)) {
      update_option('eme_events_page', $int_post_id);
   }
}

function eme_delete_events_page() {
   $events_page_id = eme_get_events_page_id();
   if ($events_page_id)
      wp_delete_post($events_page_id);
}

// Create the Manage Events and the Options submenus 
add_action('admin_menu','eme_create_events_submenu');
function eme_create_events_submenu () {
   # just in case: make sure the Settings page can be reached if something is not correct with the security settings
   if (get_option('eme_cap_settings') =='')
      $cap_settings=DEFAULT_CAP_SETTINGS;
   else
      $cap_settings=get_option('eme_cap_settings');

   $events_page_id = eme_get_events_page_id();
   if (!$events_page_id || !get_page($events_page_id))
      add_action('admin_notices', "eme_explain_events_page_missing");

   if(function_exists('add_submenu_page')) {
      // location 40: Above the appearance menu
      add_menu_page(__('Events Made Easy', 'events-made-easy'),__('Events Made Easy', 'events-made-easy'),get_option('eme_cap_list_events'),'eme-manager','eme_events_page', EME_PLUGIN_URL.'images/calendar-16.png',40);
      // Add a submenu to the custom top-level menu: 
      // edit event also needs just "add" as capability, otherwise you will not be able to edit own created events
      $plugin_page = add_submenu_page('eme-manager', __('All events', 'events-made-easy'),__('Events', 'events-made-easy'),get_option('eme_cap_list_events'),'eme-manager','eme_events_page');
      $plugin_page = add_submenu_page('eme-manager', __('Locations', 'events-made-easy'), __('Locations', 'events-made-easy'), get_option('eme_cap_list_locations'), 'eme-locations', "eme_locations_page");
      if (get_option('eme_categories_enabled')) {
         $plugin_page = add_submenu_page('eme-manager', __('Categories','events-made-easy'),__('Categories','events-made-easy'), get_option('eme_cap_categories'), "eme-categories", 'eme_categories_page');
      }
      $plugin_page = add_submenu_page('eme-manager', __('Holidays','events-made-easy'),__('Holidays','events-made-easy'), get_option('eme_cap_holidays'), "eme-holidays", 'eme_holidays_page');
      $plugin_page = add_submenu_page('eme-manager', __('Custom Fields','events-made-easy'),__('Custom Fields','events-made-easy'), get_option('eme_cap_forms'), "eme-formfields", 'eme_formfields_page');
      $plugin_page = add_submenu_page('eme-manager', __('Templates','events-made-easy'),__('Templates','events-made-easy'), get_option('eme_cap_templates'), "eme-templates", 'eme_templates_page');
      if (get_option('eme_rsvp_enabled')) {
         $plugin_page = add_submenu_page('eme-manager', __('Discounts', 'events-made-easy'), __('Discounts', 'events-made-easy'), get_option('eme_cap_discounts'), 'eme-discounts', "eme_discounts_page");
         $plugin_page = add_submenu_page('eme-manager', __('Pending Bookings', 'events-made-easy'), __('Pending Bookings', 'events-made-easy'), get_option('eme_cap_list_approve'), 'eme-registration-approval', "eme_registration_approval_page");
         $plugin_page = add_submenu_page('eme-manager', __('Approved Bookings', 'events-made-easy'), __('Approved Bookings', 'events-made-easy'), get_option('eme_cap_list_registrations'), 'eme-registration-seats', "eme_registration_seats_page");
      }
      $plugin_page = add_submenu_page('eme-manager', __('People', 'events-made-easy'), __('People', 'events-made-easy'), get_option('eme_cap_list_people'), 'eme-people', "eme_people_page");
      $plugin_page = add_submenu_page('eme-manager', __('Groups', 'events-made-easy'), __('Groups', 'events-made-easy'), get_option('eme_cap_list_people'), 'eme-groups', "eme_groups_page");
      $plugin_page = add_submenu_page('eme-manager', __('Members', 'events-made-easy'), __('Members', 'events-made-easy'), get_option('eme_cap_list_members'), 'eme-members', "eme_members_page");
      $plugin_page = add_submenu_page('eme-manager', __('Memberships', 'events-made-easy'), __('Memberships', 'events-made-easy'), get_option('eme_cap_list_members'), 'eme-memberships', "eme_memberships_page");
      $plugin_page = add_submenu_page('eme-manager', __('Countries/states','events-made-easy'),__('Countries/states','events-made-easy'), $cap_settings, "eme-countries", 'eme_countries_page');
      $plugin_page = add_submenu_page('eme-manager', __('Send Mails', 'events-made-easy'), __('Send Mails', 'events-made-easy'), get_option('eme_cap_send_mails'), 'eme-send-mails', "eme_send_mails_page");
      $plugin_page = add_submenu_page('eme-manager', __('Scheduled actions', 'events-made-easy'), __('Scheduled actions', 'events-made-easy'), $cap_settings, 'eme-cron', "eme_cron_page");
      $plugin_page = add_submenu_page('eme-manager', __('Cleanup actions', 'events-made-easy'), __('Cleanup actions', 'events-made-easy'), get_option('eme_cap_cleanup'), 'eme-cleanup', "eme_cleanup_page");

      $plugin_page = add_submenu_page('eme-manager', __('Events Made Easy Settings','events-made-easy'),__('Settings','events-made-easy'), $cap_settings, "eme-options", 'eme_options_page');
      //add_action( 'admin_head-'. $plugin_page, 'eme_admin_options_script' );
      // do some option checking after the options have been updated
      // add_action( 'load-'. $plugin_page, 'eme_admin_options_save');
   }
}

function eme_explain_events_page_missing() {
   $advice = sprintf(__("Error: the special events page is not set or no longer exist, please set the option '%s' to an existing page or EME will not work correctly!",'events-made-easy'),__ ( 'Events page', 'events-made-easy'));
   ?>
   <div id="message" class="error"><p> <?php echo $advice; ?> </p></div>
   <?php
}

?>
